<template>
  <form
    id="archiveUploadForm"
    novalidate="novalidate"
  >
    <div class="form-group">
      <label for="archiveUpload">Archive DSN</label>
      <el-upload
        id="archiveUpload"
        ref="archiveUpload"
        class="upload-archive"
        drag
        action="api/checkarchive"
        :file-list="fileList"
        :data="uploadData"
        :limit="1"
      >
        <i class="el-icon-upload" />
        <div class="el-upload__text">
          Déposer l'archive ici ou <em>cliquez pour envoyer</em>
          <br>
          <br>
        </div>
        <div
          slot="tip"
          class="el-upload__tip"
        >
          Fichier zip avec une taille inférieure à 150Mo
        </div>
      </el-upload>
      <br>
      <el-checkbox v-model="isAnonymized">
        Anonymiser les données
      </el-checkbox>
      <br>
      <el-button
        size="small"
        type="primary"
        @click="processArchive()"
      >
        Envoyer
      </el-button>
    </div>
  </form>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import VanillaToasts from 'vanillatoasts'

export default {
  name: "ArchiveUploadForm",
  components: {},
  data() {
    return {
      validator: null,
      archiveUpload: null,
      fileList: [],
      uploadData: null,
      dsnFilesLength: 0,
      dsnFileAndIndex: null,
      isAnonymized: false
    }
  },
  computed: {
    ...mapGetters([
      'isLoading',
      'archiveHasError'
    ]),
  },
  mounted() {
    this.validator = $('#archiveUploadForm').submit(function(e) {
      e.preventDefault()
    })
  },
  methods: {
    ...mapActions([
      'sendArchive',
      'loadingStarts',
      'loadingEnds',
      'fetchDsnFiles',
    ]),
    processArchive() {
      let totalFilesSize = 0;
      if(this.$refs.archiveUpload.uploadFiles.length>1) {
        VanillaToasts.create({
          title: 'Transmission d\'archive',
          text: 'Merci de transmettre une seule archive.',
          type: 'error',
          timeout: 5000,
        });
      }
      this.$refs.archiveUpload.uploadFiles.forEach((file) => {
        totalFilesSize+=file.size
      })
      if(totalFilesSize > 150000000) {
        VanillaToasts.create({
          title: 'Transmission d\'archive',
          text: 'Taille limite atteinte 150 Mo',
          type: 'error',
          timeout: 5000,
        });
      }
      let formData = new FormData();
      if(this.$refs.archiveUpload.uploadFiles!==null) {
        if(this.$refs.archiveUpload.uploadFiles.length!==0) {
          this.loadingStarts()
          for (var i = 0; i < this.$refs.archiveUpload.uploadFiles.length; i++) {
            let file = this.$refs.archiveUpload.uploadFiles[i]

            formData.append('files[' + i + ']', file.raw)
            formData.append('isAnonymized', this.isAnonymized)
          }
          this.sendArchive(formData)
            .then(()=>{
              this.$refs.archiveUpload.clearFiles()
              if(!this.archiveHasError) {
                VanillaToasts.create({
                  title: 'Transmission d\'archive',
                  text: 'Opération effectuée avec succès. Archive en cours d\'intégration...',
                  type: 'success',
                  timeout: 10000,
                });
              }
              this.fetchDsnFiles()
              this.loadingEnds()
            })
            .catch(()=>{
              this.$refs.archiveUpload.clearFiles()
              this.loadingEnds()
            })
        }
      }
    }
  }
}
</script>

<style>
.el-upload .el-upload__input {
  display: none !important;
}
</style>